#!/bin/bash

echo This is a setup script that will find out some site specific things
echo and set these in approptiate places. No files will be copied to the
echo rest of the filesystem.
echo
echo It is assumed that this script is run from the directory where the
echo cached-dryrun will also be run. i e unpack tarball in correct
echo location and dont move it after this script is run.
echo 
echo Note that all yes/no questions default to no.
echo 
echo Continue?

read -p '(y/N) ' ANS

[ $ANS = 'y' ] || [ $ANS = 'Y' ] || exit 0

echo Finding which version of slapd to use
if [ -x /usr/local/libexec/slapd ]
    then
    SLAPD=/usr/local/libexec/slapd
    elif [ -x /usr/libexec/slapd ]
    then
    SLAPD=/usr/libexec/slapd
    elif [ -x /usr/local/sbin/slapd ]
    then
    SLAPD=/usr/local/sbin/slapd
    elif [ -x /usr/sbin/slapd ]
    then
    SLAPD=/usr/sbin/slapd
fi

if [ -z $SLAPD ]
    then
    echo Could not automatically find slapd.
    else
    echo Should $SLAPD be used?
    read -p '(y/N) ' ANS
    [[ $ANS = 'y' ]] || [[ $ANS = 'Y' ]] || SLAPD=''
fi

if [ -z $SLAPD ]
    then
    echo Enter which binary to use as slapd with full path!
    read -p '> ' SLAPD
fi

echo Using $SLAPD

SLAPDPORT=8535

echo Use 8535 as port for slapd?
read -p '(y/N) ' ANS
[ $ANS = 'y' ] || [ $ANS = 'Y' ] || SLAPDPORT=''

if [ -z $SLAPDPORT ]
    then
    echo 'Which tcp port should slapd bind to?'
    read -p '> ' SLAPDPORT
fi

echo 'The openldap demon slapd can be compiled to load modules dynamically.'
echo 'In that case the hdb backend module could be configuered to use this.'
echo 'This is probably NOT the most common way to configure things though -'
echo 'at least not for this backend so dont assume this to be the default.'
echo 
echo 'Does slapd load the hdb backend as a module?'

read -p '(y/N) ' ANS

if [ $ANS = 'y' ] || [ $ANS = 'Y' ]
    then
    echo 'Give the name of the module with full path!'
    read  -p '> ' BACKHDB
    BACKHDBNAME=`basename $BACKHDB`
    BACKHDBDIR=`dirname $BACKHDB`
    BACKHDB="modulepath	$BACKHDBDIR
moduleload $BACKHDBNAME"
fi

for f in etc/slapd.conf bin/cached-dryrun bin/cached-dryrun.pl
do
  perl -pe "
s|<BACKHDB>|$BACKHDB|;
s|<SLAPDPORT>|$SLAPDPORT|;
s|<SLAPD>|$SLAPD|;
s|<PWD>|$PWD|;
" ${f}.in > $f
done

chmod +x bin/cached-dryrun bin/cached-dryrun.pl
chmod 640 etc/slapd.conf
